/*
 * This file is part of the TYPO3 CMS project.
 *
 * It is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License, either version 2
 * of the License, or any later version.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 * The TYPO3 project - inspiring people to share!
 */
define(["require","exports","jquery","TYPO3/CMS/Core/Ajax/AjaxRequest","./Module/PasswordStrength","./Renderable/InfoBox","./Renderable/ProgressBar","./Renderable/Severity"],(function(e,t,s,a,n,r,c,o){"use strict";return new class{constructor(){this.selectorBody=".t3js-body",this.selectorModuleContent=".t3js-module-content",this.selectorMainContent=".t3js-installer-content",this.selectorProgressBar=".t3js-installer-progress",this.selectorDatabaseConnectOutput=".t3js-installer-databaseConnect-output",this.selectorDatabaseSelectOutput=".t3js-installer-databaseSelect-output",this.selectorDatabaseDataOutput=".t3js-installer-databaseData-output",this.initializeEvents(),s(()=>{this.initialize()})}initializeEvents(){s(document).on("click",".t3js-installer-environmentFolders-retry",e=>{e.preventDefault(),this.showEnvironmentAndFolders()}),s(document).on("click",".t3js-installer-environmentFolders-execute",e=>{e.preventDefault(),this.executeEnvironmentAndFolders()}),s(document).on("click",".t3js-installer-databaseConnect-execute",e=>{e.preventDefault(),this.executeDatabaseConnect()}),s(document).on("click",".t3js-installer-databaseSelect-execute",e=>{e.preventDefault(),this.executeDatabaseSelect()}),s(document).on("click",".t3js-installer-databaseData-execute",e=>{e.preventDefault(),this.executeDatabaseData()}),s(document).on("click",".t3js-installer-defaultConfiguration-execute",e=>{e.preventDefault(),this.executeDefaultConfiguration()}),s(document).on("keyup",".t3-install-form-password-strength",()=>{n.initialize(".t3-install-form-password-strength")}),s(document).on("change","#t3js-connect-database-driver",e=>{let t=s(e.currentTarget).val();s(".t3-install-driver-data").hide(),s(".t3-install-driver-data input").attr("disabled","disabled"),s("#"+t+" input").attr("disabled",null),s("#"+t).show()})}initialize(){this.setProgress(0),this.getMainLayout()}getUrl(e){let t=location.href;return t=t.replace(location.search,""),void 0!==e&&(t=t+"?install[action]="+e),t}setProgress(e){let t=s(this.selectorProgressBar),a=0;0!==e&&(a=e/5*100,t.find(".progress-bar").empty().text(e+" / 5 - "+a+"% Complete")),t.find(".progress-bar").css("width",a+"%").attr("aria-valuenow",a)}getMainLayout(){new a(this.getUrl("mainLayout")).get({cache:"no-cache"}).then(async e=>{const t=await e.resolve();s(this.selectorBody).empty().append(t.html),this.checkInstallerAvailable()})}checkInstallerAvailable(){new a(this.getUrl("checkInstallerAvailable")).get({cache:"no-cache"}).then(async e=>{(await e.resolve()).success?this.checkEnvironmentAndFolders():this.showInstallerNotAvailable()})}showInstallerNotAvailable(){let e=s(this.selectorMainContent);new a(this.getUrl("showInstallerNotAvailable")).get({cache:"no-cache"}).then(async t=>{const s=await t.resolve();!0===s.success&&e.empty().append(s.html)})}checkEnvironmentAndFolders(){this.setProgress(1),new a(this.getUrl("checkEnvironmentAndFolders")).get({cache:"no-cache"}).then(async e=>{!0===(await e.resolve()).success?this.checkTrustedHostsPattern():this.showEnvironmentAndFolders()})}showEnvironmentAndFolders(){let e=s(this.selectorMainContent);new a(this.getUrl("showEnvironmentAndFolders")).get({cache:"no-cache"}).then(async t=>{const a=await t.resolve();if(!0===a.success){e.empty().html(a.html);let t=s(".t3js-installer-environment-details"),n=!1;Array.isArray(a.environmentStatusErrors)&&a.environmentStatusErrors.forEach(e=>{n=!0;let s=r.render(e.severity,e.title,e.message);t.append(s)}),Array.isArray(a.environmentStatusWarnings)&&a.environmentStatusWarnings.forEach(e=>{n=!0;let s=r.render(e.severity,e.title,e.message);t.append(s)}),Array.isArray(a.structureErrors)&&a.structureErrors.forEach(e=>{n=!0;let s=r.render(e.severity,e.title,e.message);t.append(s)}),n?(t.show(),s(".t3js-installer-environmentFolders-bad").show()):s(".t3js-installer-environmentFolders-good").show()}})}executeEnvironmentAndFolders(){new a(this.getUrl("executeEnvironmentAndFolders")).get({cache:"no-cache"}).then(async e=>{!0===(await e.resolve()).success&&this.checkTrustedHostsPattern()})}checkTrustedHostsPattern(){new a(this.getUrl("checkTrustedHostsPattern")).get({cache:"no-cache"}).then(async e=>{!0===(await e.resolve()).success?this.executeSilentConfigurationUpdate():this.executeAdjustTrustedHostsPattern()})}executeAdjustTrustedHostsPattern(){new a(this.getUrl("executeAdjustTrustedHostsPattern")).get({cache:"no-cache"}).then(()=>{this.executeSilentConfigurationUpdate()})}executeSilentConfigurationUpdate(){new a(this.getUrl("executeSilentConfigurationUpdate")).get({cache:"no-cache"}).then(async e=>{!0===(await e.resolve()).success?this.checkDatabaseConnect():this.executeSilentConfigurationUpdate()})}checkDatabaseConnect(){this.setProgress(2),new a(this.getUrl("checkDatabaseConnect")).get({cache:"no-cache"}).then(async e=>{!0===(await e.resolve()).success?this.checkDatabaseSelect():this.showDatabaseConnect()})}showDatabaseConnect(){let e=s(this.selectorMainContent);new a(this.getUrl("showDatabaseConnect")).get({cache:"no-cache"}).then(async t=>{const a=await t.resolve();!0===a.success&&(e.empty().html(a.html),s("#t3js-connect-database-driver").trigger("change"))})}executeDatabaseConnect(){let e=s(this.selectorDatabaseConnectOutput),t={"install[action]":"executeDatabaseConnect","install[token]":s(this.selectorModuleContent).data("installer-database-connect-execute-token")};s(s(this.selectorBody+" form").serializeArray()).each((e,s)=>{t[s.name]=s.value}),new a(this.getUrl()).post(t).then(async t=>{const s=await t.resolve();!0===s.success?this.checkDatabaseSelect():Array.isArray(s.status)&&(e.empty(),s.status.forEach(t=>{let s=r.render(t.severity,t.title,t.message);e.append(s)}))})}checkDatabaseSelect(){this.setProgress(3),new a(this.getUrl("checkDatabaseSelect")).get({cache:"no-cache"}).then(async e=>{!0===(await e.resolve()).success?this.checkDatabaseData():this.showDatabaseSelect()})}showDatabaseSelect(){let e=s(this.selectorMainContent);new a(this.getUrl("showDatabaseSelect")).get({cache:"no-cache"}).then(async t=>{const s=await t.resolve();!0===s.success&&e.empty().html(s.html)})}executeDatabaseSelect(){let e=s(this.selectorDatabaseSelectOutput),t={"install[action]":"executeDatabaseSelect","install[token]":s(this.selectorModuleContent).data("installer-database-select-execute-token")};s(s(this.selectorBody+" form").serializeArray()).each((e,s)=>{t[s.name]=s.value}),new a(this.getUrl()).post(t).then(async t=>{const s=await t.resolve();!0===s.success?this.checkDatabaseRequirements():Array.isArray(s.status)&&s.status.forEach(t=>{let s=r.render(t.severity,t.title,t.message);e.empty().append(s)})})}checkDatabaseRequirements(){let e=s(this.selectorDatabaseSelectOutput),t={"install[action]":"checkDatabaseRequirements","install[token]":s(this.selectorModuleContent).data("installer-database-check-requirements-execute-token")};s(s(this.selectorBody+" form").serializeArray()).each((e,s)=>{t[s.name]=s.value}),new a(this.getUrl()).post(t).then(async t=>{const s=await t.resolve();!0===s.success?this.checkDatabaseData():Array.isArray(s.status)&&(e.empty(),s.status.forEach(t=>{let s=r.render(t.severity,t.title,t.message);e.append(s)}))})}checkDatabaseData(){this.setProgress(4),new a(this.getUrl("checkDatabaseData")).get({cache:"no-cache"}).then(async e=>{!0===(await e.resolve()).success?this.showDefaultConfiguration():this.showDatabaseData()})}showDatabaseData(){let e=s(this.selectorMainContent);new a(this.getUrl("showDatabaseData")).get({cache:"no-cache"}).then(async t=>{const s=await t.resolve();!0===s.success&&e.empty().html(s.html)})}executeDatabaseData(){let e=s(this.selectorDatabaseDataOutput),t={"install[action]":"executeDatabaseData","install[token]":s(this.selectorModuleContent).data("installer-database-data-execute-token")};s(s(this.selectorBody+" form").serializeArray()).each((e,s)=>{t[s.name]=s.value});let n=c.render(o.loading,"Loading...","");e.empty().html(n),new a(this.getUrl()).post(t).then(async t=>{const s=await t.resolve();!0===s.success?this.showDefaultConfiguration():Array.isArray(s.status)&&s.status.forEach(t=>{let s=r.render(t.severity,t.title,t.message);e.empty().append(s)})})}showDefaultConfiguration(){let e=s(this.selectorMainContent);this.setProgress(5),new a(this.getUrl("showDefaultConfiguration")).get({cache:"no-cache"}).then(async t=>{const s=await t.resolve();!0===s.success&&e.empty().html(s.html)})}executeDefaultConfiguration(){let e={"install[action]":"executeDefaultConfiguration","install[token]":s(this.selectorModuleContent).data("installer-default-configuration-execute-token")};s(s(this.selectorBody+" form").serializeArray()).each((t,s)=>{e[s.name]=s.value}),new a(this.getUrl()).post(e).then(async e=>{const t=await e.resolve();top.location.href=t.redirect})}}}));